// Exemple de l'utilisation des methodes de Exception
//
import java.util.function.*;
import java.util.*;
import java.util.stream.*;
import java.io.*;

// ============== PROGRAMME PRINCIPAL
//
public class Exemple40
{
	public static void main(String[] args) throws Exception
    {
        try{
            Exemple1 e = new Exemple1();
            e.traitement("toto");
        }catch(Exception ex){
            System.out.println("------- toString -----");
            System.out.println(ex);
            System.out.println("------- getMessage -----");
            System.out.println(ex.getMessage());
            System.out.println("------- printStackTrace -----");
            ex.printStackTrace();
            System.out.println("------- printStackTrace dans une string -----");
            StringWriter sw = new StringWriter();
            ex.printStackTrace(new PrintWriter(sw));
            sw.flush();
            StringBuffer sb = sw.getBuffer();
            sw.close();
            String stack = sb.toString();
            System.out.println(stack);
            System.out.println("------- la pile d'exception  -----");
            StackTraceElement[] stackTrace = ex.getStackTrace();
            for(StackTraceElement e : stackTrace)
                {
                    if (e.getFileName()!=null)
                        {
                            System.out.println("=========");
                            System.out.println("classe  :"+e.getClassName());
                            System.out.println("fichier :"+e.getFileName());
                            System.out.println("ligne   :"+e.getLineNumber());
                            System.out.println("methode :"+e.getMethodName());
                        }
                }
        }
    }
}

class Exemple1
{
    public int traitement(String s)
    {
        Exemple2 e = new Exemple2();
        return e.convEntier(s);
    }
}
class Exemple2
{
    public int convEntier(String s)
    {
        return  Integer.parseInt(s);
    }
}